"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const nats_pubsub_1 = require("../nats-pubsub");
const logger_1 = require("./logger");
require("jest");
const customLogger = logger_1.logger.child({ className: '---------------async-iterator.test------------' });
describe('AsyncIterator', () => {
    it('should not trigger event on asyncIterator already returned', done => {
        const eventName = 'test5';
        const ps = new nats_pubsub_1.NatsPubSub({ logger: logger_1.logger });
        const iterator = ps.asyncIterator(eventName);
        iterator.next().then(result => {
            customLogger.trace('result: (%j)', result);
            try {
                expect(result).toBeDefined();
                expect(result.value).toBeDefined();
                expect(result.done).toBeFalsy();
            }
            catch (e) {
                done.fail(e);
            }
        });
        ps.publish(eventName, { test: 'word' });
        iterator.next().then(result => {
            customLogger.trace('result: (%j)', result);
            try {
                expect(result).toBeDefined();
                expect(result.value).not.toBeDefined();
                expect(result.done).toBeTruthy();
                done();
            }
            catch (e) {
                done.fail(e);
            }
        });
        iterator.return();
        ps.publish(eventName, { test: true });
    });
});
//# sourceMappingURL=async-iterator.test.js.map