"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var nats_pubsub_1 = require("../nats-pubsub");
var simple_mock_1 = require("simple-mock");
var nats_1 = require("nats");
require("jest");
var listener;
var publishSpy = simple_mock_1.spy(function (channel, message) { return listener && listener(channel, message); });
var subscribeSpy = simple_mock_1.spy(function (topic, options, cb) { return cb && cb(null, [__assign({}, options, { topic: topic })]); });
var unsubscribeSpy = simple_mock_1.spy(function (channel, _, cb) { return cb && cb(channel); });
var natsPackage = nats_1.default;
var connect = function () {
    return {
        publish: publishSpy,
        subscribe: subscribeSpy,
        unsubscribe: unsubscribeSpy,
        on: function (event, cb) {
            if (event === 'message') {
                listener = cb;
            }
        },
    };
};
natsPackage['connect'] = connect;
describe('NATSPubSub', function () {
    var pubSub = new nats_pubsub_1.NatsPubSub();
    it('can subscribe to specific nats channel and called whne a message is published on it', function (done) {
        var sub;
        var onMessage = function (message) {
            pubSub.unsubscribe(sub);
            try {
                expect(message).toEqual('test');
                done();
            }
            catch (e) {
                done(e);
            }
        };
        pubSub.subscribe('Posts', onMessage).then(function (subId) {
            expect(subId).toBeDefined();
            pubSub.publish('Posts', 'test');
            sub = subId;
        }).catch(function (err) { return done(err); });
    });
});
//# sourceMappingURL=pubsub.test.js.map