"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const nats_pubsub_1 = require("../nats-pubsub");
const logger_1 = require("./logger");
describe('PubSub', function () {
    it('can subscribe and is called when events happen', function (done) {
        const ps = new nats_pubsub_1.NatsPubSub({ logger: logger_1.logger });
        ps.subscribe('a', payload => {
            expect(payload).toBe('test');
            done();
        }).then(() => {
            const succeed = ps.publish('a', 'test');
            expect(succeed).toBeTruthy();
        });
    });
    it('can unsubscribe', function (done) {
        const ps = new nats_pubsub_1.NatsPubSub({ logger: logger_1.logger });
        ps.subscribe('a', payload => {
            expect(payload).toBe('test');
        }).then(subId => {
            ps.unsubscribe(subId);
            const succeed = ps.publish('a', 'test');
            expect(succeed).toBeTruthy();
            done();
        });
    });
});
//# sourceMappingURL=pusub.testNOT.js.map